--- sp2tex.lua
-- @author senzogawa
-- @release 2011/02/27 0.1.0

local _procnum

local assert = assert
local type = type
local _G = _G

local function NSDGetSprite(texnum, spnum, cellnum)
  local param = cellnum and ("%d,%d"):format(spnum, cellnum) or spnum
  local width, height, cells = NSSpGetInfo(spnum)
  if cellnum and cellnum >= 0 then cells = 1 end
  NSDCall(texnum, ("*%d,%d"):format(width * cells, height), _procnum, param)
end


--- XvCgHp̊֐񋟂܂B
module('sp2tex')

--- DLLpX
DLL = "nssp2tex.dll"

--- ֐
ProcNames = {
  sp2tex = "sp2tex"
}

--- DLL܂B
-- @param procnum NSDDLLŎ擾֐ԍ
function init(procnum)
  if type(procnum) == "number" then
    _procnum = procnum
    return
  end
  assert(not procnum)
  _procnum = NSDDLL(DLL, ProcNames.sp2tex)
end


--- wXvCgeNX`쐬܂B
-- @param texnum eNX`ԍ
-- @param spnum XvCgԍ
-- @param cellnum Zԍ(ȗ-1)
function sp2tex(texnum, spnum, cellnum)
  assert(type(texnum) == "number")
  assert(type(spnum) == "number")
  cellnum = cellnum or -1
  assert(type(cellnum) == "number")
  NSDGetSprite(texnum, spnum, cellnum)
end


--- NSDGetSpriteO[o֐ƂĒ`܂B
function defnsd()
  -- ŏfunction`ĂĒ`ς݂fłȂ̂ŁAK㏑`B
  _G.NSDGetSprite = NSDGetSprite
end
