private import std.c.windows.windows;
HINSTANCE g_hInst;

extern (C)
{
	void gc_init();
	void gc_term();
	void _minit();
	void _moduleCtor();
	//void _moduleUnitTests();
}

extern (Windows)
BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
    switch (ulReason)
    {
	case DLL_PROCESS_ATTACH:
	    gc_init();			// GC初期化
	    _minit();			// モジュールリスト初期化
	    _moduleCtor();		// モジュールコンストラクタ実行
	    //_moduleUnitTests();		// 単体テスト実行
	    break;

	case DLL_PROCESS_DETACH:
	    gc_term();			// GC終了
	    break;

	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	    // マルチスレッドは未対応です
	    return false;
    default:
    	break;
    }
    g_hInst=hInstance;
    return true;
}
